import intfifo.*;

class TestError extends Error {}

public class TestFIFO {

  public static void fail (String msg) {
    System.err.println(msg);
    throw new TestError ();
  }

  static void testFIFOWrapper (FIFOWrapper f, int max) {

    int M = max + 10;
    for (int i = 0; i < M; i++)
      f.put(i);
    for (int i = 0; i < M; i++)
      f.get(i);

    int N = max / 2;
    for (int i = 0; i < N; i++)
      f.put(i);
    for (int i = 0; i < N; i++)
      f.put(i);
    for (int i = 0; i < N; i++)
      f.get(i);
    for (int i = 0; i < N; i++)
      f.get(i);

  }

  static void testFIFO (FIFO f, int max) {
    System.err.println();
    System.err.println("Testing " + f.getClass() + "...");
    try {
      testFIFOWrapper(new FIFOWrapper (f, max), max);
      System.out.println(f.getClass() + " seems correct!");
    } catch (TestError e) {
      System.err.println(f.getClass() + " is incorrect!");
    }
  }

  public static void main(String[] args) {
    int max = 5000;
    testFIFO(new Queue1 (max), max);
    testFIFO(new Queue2 (max), max);
    testFIFO(new Queue3 (max), max);
    testFIFO(new Queue4 (max), max);
    testFIFO(new Queue5 (max), max);
    testFIFO(new Queue6 (max), max);
    testFIFO(new Queue7 (max), max);
    testFIFO(new Queue8 (max), max);
    testFIFO(new Queue9 (max), max);
    testFIFO(new Queue10 (max), max);
    testFIFO(new Queue11 (max), max);
    testFIFO(new Queue12 (max), max);
    testFIFO(new Queue13 (max), max);
    testFIFO(new Queue14 (max), max);
    testFIFO(new Queue15 (max), max);
    testFIFO(new Queue16 (max), max);
    testFIFO(new Queue17 (max), max);
  }

}
