package intfifo;


public class Queue2 implements FIFO {
	
	private int maxsize; 
	private int [] fifo;
	private int size;
	private int older; // les éléments sont dans older..older+size-1
	
	public Queue2 (int max) {
		this.maxsize = max;
		this.fifo = new int [maxsize] ;
		this.size = 0;
		this.older = 0;
	}
	
	public int size () {return this.size ;}
	
	@Override
	public void put(int n) throws FullQueueException {
		this.size++ ;
		if (this.size () == maxsize) throw new FullQueueException () ;
		int younger = (older + size - 1) % maxsize ;
		fifo[younger] = n ;
	}

	@Override
	public int get() throws EmptyQueueException {
		if (this.size () == 0) throw new EmptyQueueException () ;
		this.size-- ;
		int x = fifo[older] ;
		older = ((older + 1) % maxsize) ;
		return x ;
	}

	@Override
	public String toString () {
          String accu = "";
          int s = this.size () ;
          int current = older ;
          for (int i = 0 ; i < s ; i++) {
            accu += fifo[current] + " ";
            current = (current + 1) % maxsize ;
          }
          return accu;
        }

}
